/* 
 * Copyright (c) 1996-1995 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 */

#include <assert.h>

#include "malloc.h"

void *malloc(size_t size)
{
	size_t *chunk;

	size += sizeof(size_t);
	mem_lock();
	while (!(chunk = lmm_alloc(&malloc_lmm, size, 0)))
	{
		mem_unlock();
		if (!morecore(size))
			return 0;
		mem_lock();
	}
	mem_unlock();
	*chunk = size;
	return chunk+1;
}

void *
mustmalloc(size_t size)
{
	void *buf;

	buf = malloc(size);
	assert(buf);

	return buf;
}
