/*
 * Copyright (c) 1996 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 */

/*
 * Routine to initialize the Programmable Interval Timer (PIT).
 */

#include <flux/x86/pio.h>
#include <flux/x86/pc/pit.h>


void
init_pit(int hz) 
{
        int clk = CLKNUM / hz;

#if 0
        printf("clk = %d\n", clk);
#endif
        outb(PITCTL_PORT, (PIT_C0|PIT_SQUAREMODE|PIT_READMODE));
        outb(PITCTR0_PORT, clk & 0x00ff);
        outb(PITCTR0_PORT, (clk & 0xff00) >> 8);
}
